// Deelx.h : Declaration of the CDeelx
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef __DEELX_H_
#define __DEELX_H_

#include "resource.h"       // main symbols
#include "DeelxRegexp.h"

/////////////////////////////////////////////////////////////////////////////
// CDeelx
class ATL_NO_VTABLE CDeelx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDeelx, &CLSID_Regexp>,
	public ISupportErrorInfo,
	public IDispatchImpl<IDeelx, &IID_IDeelx, &LIBID_RegExLab>
{
public:
	CDeelx() : m_result(0)
	{
		m_pscopy = NULL;
		m_nstart = -1;
	}
	~CDeelx()
	{
		if(m_pscopy != NULL)
		{
			delete [] m_pscopy;
			m_pscopy = NULL;
		}
	}

public:

DECLARE_REGISTRY_RESOURCEID(IDR_DEELX)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDeelx)
	COM_INTERFACE_ENTRY(IDeelx)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IDeelx
public:
	STDMETHOD(get_MatchResult)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_MaxGroupNumber)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_GroupEnd)(int number, /*[out, retval]*/ long *pVal);
	STDMETHOD(get_GroupBegin)(int number, /*[out, retval]*/ long *pVal);
	STDMETHOD(get_Group)(int number, /*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_End)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_Begin)(/*[out, retval]*/ long *pVal);
	STDMETHOD(get_IsMatched)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(get_NextStart)(/*[out, retval]*/ long *pVal);
//	STDMETHOD(put_NextStart)(/*[in]*/ long newVal);
	STDMETHOD(Replace)(BSTR text, BSTR replaceto, int start, int times, /*[out, retval]*/BSTR * pVal);
	STDMETHOD(Match)(BSTR text, int start, /*[out, retval]*/VARIANT_BOOL * pVal);
	STDMETHOD(Compile)(BSTR pattern, BSTR flags);

protected:
	CDeelxRegexpW      m_regexp;
	MatchResult        m_result;
	wchar_t          * m_pscopy;
	int                m_nstart;
	int                m_nflags;
};

#endif //__DEELX_H_
