// AbsoluteGreedyElx.cpp: implementation of the CAbsoluteGreedyElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "AbsoluteGreedyElx.h"

CAbsoluteGreedyElx::CAbsoluteGreedyElx(ElxInterface * pElx, unsigned int nTimes) : CGreedyElx(pElx, nTimes)
{
}

int CAbsoluteGreedyElx::Match(ContextInterface * pContext)
{
	// mark
	ContextState state;
	pContext->Mark(state);

	unsigned int nBegin = pContext->GetCurrentPos();

	// match
	int succ = CGreedyElx::Match(pContext);

	// restore stack only
	pContext->Restore(state, 1);

	if( succ ) pContext->Push(nBegin, m_nSerial);

	return succ;
}

int CAbsoluteGreedyElx::MatchNext(ContextInterface * pContext)
{
	unsigned int nBegin = 0;

	pContext->Pop(nBegin, m_nSerial);

	pContext->SetCurrentPos(nBegin);

	return 0;
}
