// AlternativeElx.cpp: implementation of the CAlternativeElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/28 09:27:19
//

#include "AlternativeElx.h"

CAlternativeElx & CAlternativeElx::AppendElx(ElxInterface * pElx)
{
	// insert
	if(pElx != 0)
		m_lstElxs.insert(m_lstElxs.end(), pElx);

	return *this;
}

int CAlternativeElx::Match(ContextInterface * pContext)
{
	// check empty
	if(m_lstElxs.empty())
		return 1;

	int nCurrentIndex = 0;

	for(elxiter itrCurr = m_lstElxs.begin(); itrCurr != m_lstElxs.end(); itrCurr++, nCurrentIndex++)
	{
		if((*itrCurr)->Match(pContext))
		{
			pContext->Push(nCurrentIndex, m_nSerial);
			return 1;
		}
	}

	return 0;
}

int CAlternativeElx::MatchNext(ContextInterface * pContext)
{
	if(m_lstElxs.empty())
		return 0;

	// pop current index
	unsigned int nCurrentIndex = 0;
	pContext->Pop(nCurrentIndex, m_nSerial);

	// locate iterator
	elxiter itrCurr = m_lstElxs.begin();

	for(int i=0; i<nCurrentIndex; i++)
	{
		itrCurr ++;
		if(itrCurr == m_lstElxs.end())
			break;
	}

	// match nx @ iter
	if((*itrCurr)->MatchNext(pContext))
	{
		pContext->Push(nCurrentIndex, m_nSerial);
		return 1;
	}
	else
	{
		// match next iter
		itrCurr ++;
		nCurrentIndex ++;
	}

	for( ; itrCurr != m_lstElxs.end(); itrCurr++, nCurrentIndex++)
	{
		if((*itrCurr)->Match(pContext))
		{
			pContext->Push(nCurrentIndex, m_nSerial);
			return 1;
		}
	}

	return 0;
}
