// Backref.cpp: implementation of the CBackref class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "Backref.h"

CBackref::CBackref() : m_stack(0)
{
	m_nCount = 0;
	m_nCaptureDisabled = 0;
}

CBackref::~CBackref()
{

}

void CBackref::PushStart(unsigned int nStart, int bNoPush)
{
	// if not closed when push start, it is recursive
	if( ! IsClosed() )
	{
		m_nCaptureDisabled ++;
		return;
	}

	if(m_nCount > 0 && ! bNoPush)
	{
		m_stack.Push(m_nStart);
		m_stack.Push(m_nEnd  );
	}

	m_nStart = nStart;
	m_nCount ++;
}

void CBackref::PushEnd(unsigned int nEnd)
{
	if(m_nCaptureDisabled > 0)
	{
		m_nCaptureDisabled --;
		return;
	}

	m_nEnd   = nEnd;
	m_nCount ++;
}

void CBackref::PopStart()
{
	if(m_nCaptureDisabled > 0)
	{
		m_nCaptureDisabled --;
		return;
	}

	if(m_nCount > 0)
	{
		m_nCount --;

		m_stack.Pop(m_nEnd  );
		m_stack.Pop(m_nStart);
	}
}

void CBackref::PopEnd()
{
	if(m_nCaptureDisabled > 0)
	{
		m_nCaptureDisabled ++;
		return;
	}

	m_nCount --;
}

int CBackref::GetBackref(unsigned int & nStart, unsigned int & nEnd, unsigned int nCurrentPos)
{
	if(!Captured()) return 0;

	nStart = m_nStart;
	nEnd   = IsClosed() ? m_nEnd : nCurrentPos;

	return 1;
}

void CBackref::Reset()
{
	StackState state = {0, 0};
	m_stack.Restore(state);

	m_nCount = 0;
	m_nCaptureDisabled = 0;
}
