// Backref.h: interface for the CBackref class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef AFX_BACKREF_H__
#define AFX_BACKREF_H__

#include "PackedStack.h"

class CBackref
{
public:
	void PushStart(unsigned int nStart, int bNoPush = 0);
	void PushEnd  (unsigned int nEnd);
	void PopStart ();
	void PopEnd   ();

	inline int Captured() { return m_nCount > 0; }
	inline int IsClosed() { return ! (m_nCount & 0x01); }

	int GetBackref(unsigned int & nStart, unsigned int & nEnd, unsigned int nCurrentPos);

public:
	void Reset();
	CBackref();
	virtual ~CBackref();

protected:
	CPackedStack m_stack;
	unsigned int m_nStart, m_nEnd;
	int m_nCount;
	int m_nCaptureDisabled;
};

#endif//AFX_BACKREF_H__
