// DelegateElx.cpp : 
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "DelegateElx.h"

CDelegateElx::CDelegateElx(ElxInterface * pElx, ElxInterface * pNext, unsigned int nParam1, unsigned int nParam2)
{
	SetElxs(pElx, pNext, nParam1, nParam2);
}

void CDelegateElx::SetElxs(ElxInterface * pElx, ElxInterface * pNext, unsigned int nParam1, unsigned int nParam2)
{
	m_pElx    = pElx;
	m_pNext   = pNext;
	m_nParam1 = nParam1;
	m_nParam2 = nParam2;
}

int CDelegateElx::Match(ContextInterface * pContext)
{
	if(m_pElx == 0)
		return 1;

	if(!m_pElx->Match(pContext))
		return 0;

	if(!m_pNext)
		return 1;

	while(!m_pNext->Match(pContext))
	{
		if(!m_pElx->MatchNext(pContext))
			return 0;
	}

	return 1;
}

//
//
int CDelegateElx::MatchNext(ContextInterface * pContext)
{
	if(m_pElx == 0)
		return 0;

	if(m_pNext && m_pNext->MatchNext(pContext))
		return 1;
	else
	{
		if(!m_pElx->MatchNext(pContext))
			return 0;

		if(!m_pNext)
			return 1;

		while(!m_pNext->Match(pContext))
		{
			if(!m_pElx->MatchNext(pContext))
				return 0;
		}

		return 1;
	}
}
