// FixedRepeatElx.cpp: implementation of the CFixedRepeatElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/07/17 07:18:25
//

#include "FixedRepeatElx.h"

CFixedRepeatElx::CFixedRepeatElx(ElxInterface * pElx, int nTimes)
{
	m_pElx   = pElx;
	m_nTimes = nTimes;
}

int CFixedRepeatElx::Match(ContextInterface * pContext)
{
	// check
	if(m_nTimes == 0) return 1;

	int nCurrentTimes = 0;

	do{
		// times count
		if(m_pElx->Match(pContext))
		{
			nCurrentTimes ++;
			if(nCurrentTimes >= m_nTimes)
				return 1;
		}
		else
		{
			while(nCurrentTimes > 0 && !m_pElx->MatchNext(pContext)) nCurrentTimes --;
		}
	}
	while(nCurrentTimes > 0);

	return 0;
}

int CFixedRepeatElx::MatchNext(ContextInterface * pContext)
{
	// check
	if(m_nTimes == 0) return 0;

	int nCurrentTimes = m_nTimes;

	// match nx
	while(nCurrentTimes > 0 && !m_pElx->MatchNext(pContext)) nCurrentTimes --;

	if( nCurrentTimes == m_nTimes) return 1;

	// match rest
	while(nCurrentTimes > 0)
	{
		// times count
		if(m_pElx->Match(pContext))
		{
			nCurrentTimes ++;
			if(nCurrentTimes >= m_nTimes)
				return 1;
		}
		else
		{
			while(nCurrentTimes > 0 && !m_pElx->MatchNext(pContext)) nCurrentTimes --;
		}
	}

	return 0;
}
