// FixedStringElx.h
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef _FIXED_STRING_ELX_H__
#define _FIXED_STRING_ELX_H__

#include "ElxInterface.h"
#include "StringRef.h"

template <typename CHART> class CFixedStringElxT : public ElxInterface
{
public:
	int Match(ContextInterface * pContext)
	{
		const CHART * pcsz   = (const CHART *)pContext->GetTarget();
		int  nBegin = pContext->GetCurrentPos();

		int bsucc;

		// check length
		if(m_bRightLeft)
		{
			if(nBegin < m_nLength)
				return 0;

			if(m_bIgnoreCase)
				bsucc = ! m_szPattern.nCompareNoCase(pcsz + (nBegin - m_nLength));
			else
				bsucc = ! m_szPattern.nCompare(pcsz + (nBegin - m_nLength));

			if(bsucc)
				pContext->SetCurrentPos(nBegin - m_nLength);
		}
		else
		{
			if(nBegin + m_nLength > pContext->GetLength())
				return 0;

			if(m_bIgnoreCase)
				bsucc = ! m_szPattern.nCompareNoCase(pcsz + nBegin);
			else
				bsucc = ! m_szPattern.nCompare(pcsz + nBegin);

			if(bsucc)
				pContext->SetCurrentPos(nBegin + m_nLength);
		}

		return bsucc;
	}
	int MatchNext(ContextInterface * pContext)
	{
		pContext->SetCurrentPos(pContext->GetCurrentPos() + (m_bRightLeft ? m_nLength : -m_nLength));
		return 0;
	}

public:
	CFixedStringElxT(const CHART * fixptn, int length, int bRightLeft = 0, int bIgnoreCase = 0)
		: m_szPattern(fixptn, length)
	{
		m_bRightLeft  = bRightLeft;
		m_bIgnoreCase = bIgnoreCase;
		m_nLength     = length;
	}

protected:
	StringCopyT <CHART> m_szPattern;
	int m_bRightLeft, m_bIgnoreCase, m_nLength;
};

#endif//_FIXED_STRING_ELX_H__
