// GreedyElx.cpp: implementation of the CGreedyElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/07/17 03:35:16
//

#include "GreedyElx.h"

CGreedyElx::CGreedyElx(ElxInterface * pElx, unsigned int nTimes)
{
	m_pElx          = pElx;
	m_nTimes        = nTimes;
}

int CGreedyElx::Match(ContextInterface * pContext)
{
	unsigned int nCurrentTimes = 0;

	while(m_pElx->Match(pContext))
	{
		// times
		nCurrentTimes ++;

		// limit
		if(nCurrentTimes >= m_nTimes)
			break;
	}

	pContext->Push(nCurrentTimes, m_nSerial);

	return 1;
}

int CGreedyElx::MatchNext(ContextInterface * pContext)
{
	unsigned int nCurrentTimes = 0;

	pContext->Pop(nCurrentTimes, m_nSerial);

	if(nCurrentTimes == 0)
		return 0;

	if(!m_pElx->MatchNext(pContext))
	{
		nCurrentTimes --;
	}

	pContext->Push(nCurrentTimes, m_nSerial);

	return 1;
}
