// IndependentElx.cpp: implementation of the CIndependentElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "IndependentElx.h"

CIndependentElx::CIndependentElx(ElxInterface * pElx)
{
	m_pElx = pElx;
}

int CIndependentElx::Match(ContextInterface * pContext)
{
	// mark
	ContextState state;
	pContext->Mark(state);

	unsigned int nBegin = pContext->GetCurrentPos();

	// match
	int bsucc = m_pElx->Match(pContext);

	// restore stack
	pContext->Restore(state, 1);

	// save begin pos
	if( bsucc ) pContext->Push(nBegin, m_nSerial);

	return bsucc;
}

int CIndependentElx::MatchNext(ContextInterface * pContext)
{
	unsigned int nBegin = 0;

	pContext->Pop(nBegin, m_nSerial);

	pContext->SetCurrentPos(nBegin);

	return 0;
}
