// MatchResult.cpp
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "DeelxRegexp.h"
#include "RegexContext.h"
#include "PreBuilder.h"

int MatchResult::IsMatched()
{
	if(m_pPreserved != 0)
		return ((int *)m_pPreserved)[0];
	else
		return 0;
}

int MatchResult::MaxGroupNumber()
{
	if(m_pPreserved != 0)
		return ((int *)m_pPreserved)[1];
	else
		return 0;
}

int MatchResult::GetStart()
{
	if(m_pPreserved != 0)
		return ((int *)m_pPreserved)[2];
	else
		return -1;
}

int MatchResult::GetEnd()
{
	if(m_pPreserved != 0)
		return ((int *)m_pPreserved)[3];
	else
		return -1;
}

int MatchResult::GetGroupStart(int nGroupNumber)
{
	if(m_pPreserved != 0)
		return ((int *)m_pPreserved)[2 + nGroupNumber * 2];
	else
		return -1;
}

int MatchResult::GetGroupEnd(int nGroupNumber)
{
	if(m_pPreserved != 0)
		return ((int *)m_pPreserved)[2 + nGroupNumber * 2 + 1];
	else
		return -1;
}

MatchResult::MatchResult(void * pData, int nMaxNumber)
{
	if(pData == 0)
	{
		m_pPreserved = 0;
	}
	else
	{
		unsigned int nStart, nEnd;
		CMiniBufferT <int> data;

		data.Append(1);
		data.Append(nMaxNumber);

		CRegexContext * pContext = (CRegexContext *)pData;

		for(int i=0; i<=nMaxNumber; i++)
		{
			int bMatched = pContext->GetBackref(i, nStart, nEnd);

			if(bMatched)
			{
				data.Append(nStart < nEnd ? nStart : nEnd);
				data.Append(nStart > nEnd ? nStart : nEnd);
			}
			else
			{
				data.Append( -1 );
				data.Append( -1 );
			}
		}

		m_pPreserved = (void *)data.Detach();
	}
}

MatchResult::~MatchResult()
{
	if(m_pPreserved != 0)
	{
		int * pint = (int *) m_pPreserved;
		delete [] pint;
		m_pPreserved = 0;
	}
}

MatchResult & MatchResult::operator = (const MatchResult & result)
{
	if(m_pPreserved != 0 && result.m_pPreserved != 0)
	{
		int * nint = (int *) result.m_pPreserved;
		int * pint = (int *) m_pPreserved;

		if(nint[1] <= pint[1])
		{
			memcpy(pint, nint, (nint[1] + 2) * 2 * sizeof(int));
			return *this;
		}
	}

	if(m_pPreserved != 0)
	{
		int * pint = (int *) m_pPreserved;
		delete [] pint;
		m_pPreserved = 0;
	}

	if(result.m_pPreserved != 0)
	{
		int * nint = (int *) result.m_pPreserved;
		int * pint = new int[(nint[1] + 2) * 2];

		m_pPreserved = pint;
		memcpy(pint, nint, (nint[1] + 2) * 2 * sizeof(int));
	}

	return *this;
}
