// PackedStack.h : Interface of packedstack
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef _PACKED_STACK_H_
#define _PACKED_STACK_H_

#include "StackInterface.h"

#define DEFAULT_INIT  64
#define REPEAT_MAX    0x3F

class CPackedStack : public StackInterface
{
public:
	void Push(unsigned int   n, unsigned int id = 0);
	int  Pop (unsigned int & n, unsigned int id = 0);
	int  Peek(unsigned int & n, unsigned int id = 0);

	void Mark   (StackState & state);
	void Restore(StackState   state);

public:
	CPackedStack(int nInitialSize = DEFAULT_INIT);
	virtual ~CPackedStack();

protected:
	inline int  IsIddata() { return (m_pBuffer[m_nSize-1] & 0xC0) == 0x80; }
	inline int  IsRepeat() { return (m_pBuffer[m_nSize-1] & 0xC0) == 0x40; }

	inline int  GetIddata() { return (*(short*)(m_pBuffer+m_nSize-2)) & 0x3FFF; }
	inline int  GetRepeat() { return (m_pBuffer[m_nSize-1] & 0x3F); }
	inline void IncRepeat() { m_pBuffer[m_nSize-1]++; }
	inline void DecRepeat() { m_pBuffer[m_nSize-1]--; }

protected:
	unsigned char * m_pBuffer;
	int             m_nBufSize;
	int             m_nSize;
	unsigned int    m_nCurrentId;

protected:
	unsigned int ReadValue(int nSize, int used);
	void WriteValue(unsigned int n, int used);
	int BytesUsed(int nSize);
	int BytesNeed(unsigned int n);
	void EnLarge();
};

#endif//_PACKED_STACK_H_

