// RegexContext.h: interface for the CRegexContext class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#ifndef AFX_REGEXCONTEXT_H__
#define AFX_REGEXCONTEXT_H__

#include <vector>
#include "PackedStack.h"
#include "ContextInterface.h"

class CBackref;

class CRegexContext : public ContextInterface
{
// pos
public:
	virtual void SetCurrentPos(unsigned int nPos);
	virtual unsigned int GetCurrentPos() { return m_nCurrentPos; };

	// position for '\G'
	virtual void SetGlobalPos(unsigned int nPos);
	virtual unsigned int GetGlobalPos() { return m_nGlobalPos; };

	virtual void SetLastLength(int nLength) { m_nLastLength = nLength; }
	virtual int GetLastLength() { return m_nLastLength; }

// stack
public:
	virtual void Push(unsigned int   n, unsigned int id) {        m_stack.Push(n, id); }
	virtual int  Pop (unsigned int & n, unsigned int id) { return m_stack.Pop (n, id); }

// state
public:
	virtual void Mark   (ContextState & state);
	virtual void Restore(ContextState   state, int stackonly = 0);

// backref
public:
	virtual void PushBackrefStart(int nbackref, unsigned int nStart, int bNoPush = 0);
	virtual void PushBackrefEnd  (int nbackref, unsigned int nEnd);

	virtual void PopBackrefStart (int nbackref);
	virtual void PopBackrefEnd   (int nbackref);

	virtual int  GetBackref(int nbackref, unsigned int & nStart, unsigned int & nEnd);

	virtual int  GetLastParenMatch();

// initialize
public:
	virtual void   ResetAll(void * pTarget, int nLength);
	virtual void   ResetStack();

	virtual void * GetTarget() { return m_pMatchTarget ; }
	virtual int    GetLength() { return m_nTargetLength; }

/////////////////////////////////////////

// Constructor
public:
	CRegexContext();
	virtual ~CRegexContext();

// Attribute
protected:
	CPackedStack m_stack;
	CPackedStack m_lastParenMatch;
	std::vector <CBackref *> m_vbackref;

	void * m_pMatchTarget;
	int    m_nTargetLength;

protected:
	CBackref * GetOrCreateAt(int nIndex);

protected:
	int m_nLastLength;
	unsigned int m_nCurrentPos;
	unsigned int m_nGlobalPos;
};

#endif//AFX_REGEXCONTEXT_H__
