// ReluctantElx.cpp: implementation of the CReluctantElx class.
//
// Copyright 2006 (c) RegExLab.com
//
// Author: ʷΰ (sswater shi)
//
// 2006/06/20 03:17:12
//

#include "ReluctantElx.h"

CReluctantElx::CReluctantElx(ElxInterface * pElx, unsigned int nTimes)
{
	m_pElx          = pElx;
	m_nTimes        = nTimes;
}

int CReluctantElx::Match(ContextInterface * pContext)
{
	// first zero time
	pContext->Push(0, m_nSerial);

	return 1;
}

int CReluctantElx::MatchNext(ContextInterface * pContext)
{
	unsigned nCurrentTimes = 0;

	pContext->Pop(nCurrentTimes, m_nSerial);

	// limit
	if(nCurrentTimes >= m_nTimes)
		return 0;

	// next match
	if(m_pElx->Match(pContext))
	{
		nCurrentTimes++;

		pContext->Push(nCurrentTimes, m_nSerial);

		return 1;
	}

	while(nCurrentTimes > 0 && !m_pElx->MatchNext(pContext))
	{
		nCurrentTimes --;
	}

	if(nCurrentTimes > 0)
	{
		pContext->Push(nCurrentTimes, m_nSerial);

		return 1;
	}
	else
	{
		return 0;
	}
}
