
#include <stdio.h>
#include "DeelxRegexp.h"

int main()
{
    char ptn[] = "[:digit:]+";
    char txt[] = "The book cost $12.34";

    CDeelxRegexp re( ptn );

	ContextInterface * pContext = re.PrepareMatch(txt);

    MatchResult result = re.Match(pContext);

    while(result.IsMatched())
    {
        for(int i=0; i<=result.MaxGroupNumber(); i++)
        {
            printf("%d: %.*s\n", i,
                result.GetGroupEnd(i) - result.GetGroupStart(i),
                txt + result.GetGroupStart(i)
            );
        }

        printf("\n");

        result = re.Match(pContext);
    }

	re.ReleaseContext(pContext);

    return 0;
}
